import { IgRect } from './IgRect';
import { ShapefileConverter } from "./ShapefileConverter";
import { ShapeType } from "./ShapeType";
import { Header } from "./Header";
import { AsyncCompletedEventArgs } from './AsyncCompletedEventArgs';
import { List$1 } from './List$1';
import { ShapefileRecord } from './ShapefileRecord';
/**
 * Class used to convert Shapefiles into CLR objects.
*/
export declare class ShapeDataSource {
    protected createImplementation(): ShapefileConverter;
    protected _implementation: any;
    readonly i: ShapefileConverter;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    private _databaseSource;
    /**
     * Gets the string Uri path of the .dbf portion of the Shapefile
    */
    /**
     * Sets the string Uri path of the .dbf portion of the Shapefile
    */
    databaseSource: string;
    private _shapefileSource;
    /**
     * Gets the string Uri path of the .shp portion of the Shapefile
    */
    /**
     * Sets the string Uri path of the .shp portion of the Shapefile
    */
    shapefileSource: string;
    dataBind(): void;
    private _importCompleted;
    private _importCompleted_wrapped;
    /**
     * Occurs when the Shapefile has been imported from both the ShapefileSource and DatabaseSource Uris.
    */
    importCompleted: (s: any, e: AsyncCompletedEventArgs) => void;
    /**
    * Gets the point data.
    */
    getPointData(): List$1<ShapefileRecord>;
    /**
 * Gets the world bounding rectangle, as read from the header of the Shapefile.
*/
    worldRect: IgRect;
    /**
     * Gets the shape type, as read from the header of the Shapefile.
    */
    readonly shapeType: ShapeType;
    /**
     * Gets the header of the Shapefile.
    */
    shapeHeader: Header;
}
